Index: kernel/generic/src/synch/workqueue.c
===================================================================
--- kernel/generic/src/synch/workqueue.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/synch/workqueue.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
  */
 
+#include <assert.h>
 #include <synch/workqueue.h>
 #include <synch/spinlock.h>
@@ -189,5 +190,5 @@
 	if (workq) {
 		if (workq_init(workq, name)) {
-			ASSERT(!workq_corrupted(workq));
+			assert(!workq_corrupted(workq));
 			return workq;
 		}
@@ -202,5 +203,5 @@
 void workq_destroy(struct work_queue *workq)
 {
-	ASSERT(!workq_corrupted(workq));
+	assert(!workq_corrupted(workq));
 	
 	irq_spinlock_lock(&workq->lock, true);
@@ -214,5 +215,5 @@
 		workq_stop(workq);
 	} else {
-		ASSERT(0 == running_workers);
+		assert(0 == running_workers);
 	}
 	
@@ -264,5 +265,5 @@
 static bool add_worker(struct work_queue *workq)
 {
-	ASSERT(!workq_corrupted(workq));
+	assert(!workq_corrupted(workq));
 
 	thread_t *thread = thread_create(worker_thread, workq, TASK, 
@@ -273,5 +274,5 @@
 		
 		/* cur_worker_cnt proactively increased in signal_worker_logic() .*/
-		ASSERT(0 < workq->cur_worker_cnt);
+		assert(0 < workq->cur_worker_cnt);
 		--workq->cur_worker_cnt;
 		
@@ -312,5 +313,5 @@
 		
 		/* cur_worker_cnt proactively increased in signal_worker() .*/
-		ASSERT(0 < workq->cur_worker_cnt);
+		assert(0 < workq->cur_worker_cnt);
 		--workq->cur_worker_cnt;
 	}
@@ -334,5 +335,5 @@
 void workq_stop(struct work_queue *workq)
 {
-	ASSERT(!workq_corrupted(workq));
+	assert(!workq_corrupted(workq));
 	
 	interrupt_workers(workq);
@@ -346,5 +347,5 @@
 
 	/* workq_stop() may only be called once. */
-	ASSERT(!workq->stopping);
+	assert(!workq->stopping);
 	workq->stopping = true;
 	
@@ -358,5 +359,5 @@
 static void wait_for_workers(struct work_queue *workq)
 {
-	ASSERT(!PREEMPTION_DISABLED);
+	assert(!PREEMPTION_DISABLED);
 	
 	irq_spinlock_lock(&workq->lock, true);
@@ -375,5 +376,5 @@
 	}
 	
-	ASSERT(list_empty(&workq->workers));
+	assert(list_empty(&workq->workers));
 	
 	/* Wait for deferred add_worker_op(), signal_worker_op() to finish. */
@@ -473,5 +474,5 @@
 	work_func_t func, bool can_block)
 {
-	ASSERT(!workq_corrupted(workq));
+	assert(!workq_corrupted(workq));
 	
 	bool success = true;
@@ -521,17 +522,17 @@
 static size_t active_workers_now(struct work_queue *workq)
 {
-	ASSERT(irq_spinlock_locked(&workq->lock));
+	assert(irq_spinlock_locked(&workq->lock));
 	
 	/* Workers blocked are sleeping in the work function (ie not idle). */
-	ASSERT(workq->blocked_worker_cnt <= workq->cur_worker_cnt);
+	assert(workq->blocked_worker_cnt <= workq->cur_worker_cnt);
 	/* Idle workers are waiting for more work to arrive in condvar_wait. */
-	ASSERT(workq->idle_worker_cnt <= workq->cur_worker_cnt);
+	assert(workq->idle_worker_cnt <= workq->cur_worker_cnt);
 	
 	/* Idle + blocked workers == sleeping worker threads. */
 	size_t sleeping_workers = workq->blocked_worker_cnt + workq->idle_worker_cnt;
 	
-	ASSERT(sleeping_workers	<= workq->cur_worker_cnt);
+	assert(sleeping_workers	<= workq->cur_worker_cnt);
 	/* Workers pending activation are idle workers not yet given a time slice. */
-	ASSERT(workq->activate_pending <= workq->idle_worker_cnt);
+	assert(workq->activate_pending <= workq->idle_worker_cnt);
 	
 	/* 
@@ -550,5 +551,5 @@
 static size_t active_workers(struct work_queue *workq)
 {
-	ASSERT(irq_spinlock_locked(&workq->lock));
+	assert(irq_spinlock_locked(&workq->lock));
 	
 	/* 
@@ -573,10 +574,10 @@
 static void signal_worker_op(struct work_queue *workq)
 {
-	ASSERT(!workq_corrupted(workq));
+	assert(!workq_corrupted(workq));
 
 	condvar_signal(&workq->activate_worker);
 	
 	irq_spinlock_lock(&workq->lock, true);
-	ASSERT(0 < workq->pending_op_cnt);
+	assert(0 < workq->pending_op_cnt);
 	--workq->pending_op_cnt;
 	irq_spinlock_unlock(&workq->lock, true);
@@ -593,6 +594,6 @@
 static signal_op_t signal_worker_logic(struct work_queue *workq, bool can_block)
 {
-	ASSERT(!workq_corrupted(workq));
-	ASSERT(irq_spinlock_locked(&workq->lock));
+	assert(!workq_corrupted(workq));
+	assert(irq_spinlock_locked(&workq->lock));
 	
 	/* Only signal workers if really necessary. */
@@ -645,5 +646,5 @@
 			 */
 			if (need_worker && !can_block && 0 == active) {
-				ASSERT(0 == workq->idle_worker_cnt);
+				assert(0 == workq->idle_worker_cnt);
 				
 				irq_spinlock_lock(&nonblock_adder.lock, true);
@@ -681,5 +682,5 @@
 	}
 	
-	ASSERT(arg != NULL);
+	assert(arg != NULL);
 	
 	struct work_queue *workq = arg;
@@ -697,5 +698,5 @@
 static bool dequeue_work(struct work_queue *workq, work_t **pwork_item)
 {
-	ASSERT(!workq_corrupted(workq));
+	assert(!workq_corrupted(workq));
 	
 	irq_spinlock_lock(&workq->lock, true);
@@ -704,5 +705,5 @@
 	if (!workq->stopping && worker_unnecessary(workq)) {
 		/* There are too many workers for this load. Exit. */
-		ASSERT(0 < workq->cur_worker_cnt);
+		assert(0 < workq->cur_worker_cnt);
 		--workq->cur_worker_cnt;
 		list_remove(&THREAD->workq_link);
@@ -729,5 +730,5 @@
 		
 #ifdef CONFIG_DEBUG
-		ASSERT(!work_item_corrupted(*pwork_item));
+		assert(!work_item_corrupted(*pwork_item));
 		(*pwork_item)->cookie = 0;
 #endif
@@ -738,5 +739,5 @@
 	} else {
 		/* Requested to stop and no more work queued. */
-		ASSERT(workq->stopping);
+		assert(workq->stopping);
 		--workq->cur_worker_cnt;
 		stop = true;
@@ -751,5 +752,5 @@
 static bool worker_unnecessary(struct work_queue *workq)
 {
-	ASSERT(irq_spinlock_locked(&workq->lock));
+	assert(irq_spinlock_locked(&workq->lock));
 	
 	/* No work is pending. We don't need too many idle threads. */
@@ -775,11 +776,11 @@
 	
 	/* Ignore lock ordering just here. */
-	ASSERT(irq_spinlock_locked(&workq->lock));
+	assert(irq_spinlock_locked(&workq->lock));
 	
 	_condvar_wait_timeout_irq_spinlock(&workq->activate_worker,
 		&workq->lock, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE);
 
-	ASSERT(!workq_corrupted(workq));
-	ASSERT(irq_spinlock_locked(&workq->lock));
+	assert(!workq_corrupted(workq));
+	assert(irq_spinlock_locked(&workq->lock));
 	
 	THREAD->workq_idling = false;
@@ -791,14 +792,14 @@
 void workq_before_thread_is_ready(thread_t *thread)
 {
-	ASSERT(thread);
-	ASSERT(irq_spinlock_locked(&thread->lock));
+	assert(thread);
+	assert(irq_spinlock_locked(&thread->lock));
 
 	/* Worker's work func() is about to wake up from sleeping. */
 	if (thread->workq && thread->workq_blocked) {
 		/* Must be blocked in user work func() and not be waiting for work. */
-		ASSERT(!thread->workq_idling);
-		ASSERT(thread->state == Sleeping);
-		ASSERT(THREAD != thread);
-		ASSERT(!workq_corrupted(thread->workq));
+		assert(!thread->workq_idling);
+		assert(thread->state == Sleeping);
+		assert(THREAD != thread);
+		assert(!workq_corrupted(thread->workq));
 		
 		/* Protected by thread->lock */
@@ -814,11 +815,11 @@
 void workq_after_thread_ran(void)
 {
-	ASSERT(THREAD);
-	ASSERT(irq_spinlock_locked(&THREAD->lock));
+	assert(THREAD);
+	assert(irq_spinlock_locked(&THREAD->lock));
 
 	/* Worker's work func() is about to sleep/block. */
 	if (THREAD->workq && THREAD->state == Sleeping && !THREAD->workq_idling) {
-		ASSERT(!THREAD->workq_blocked);
-		ASSERT(!workq_corrupted(THREAD->workq));
+		assert(!THREAD->workq_blocked);
+		assert(!workq_corrupted(THREAD->workq));
 		
 		THREAD->workq_blocked = true;
@@ -834,5 +835,5 @@
 		
 		if (op) {
-			ASSERT(add_worker_noblock_op == op || signal_worker_op == op);
+			assert(add_worker_noblock_op == op || signal_worker_op == op);
 			op(THREAD->workq);
 		}
@@ -903,5 +904,5 @@
 			struct work_queue, nb_link);
 
-		ASSERT(!workq_corrupted(*pworkq));
+		assert(!workq_corrupted(*pworkq));
 		
 		list_remove(&(*pworkq)->nb_link);
Index: kernel/generic/src/syscall/copy.c
===================================================================
--- kernel/generic/src/syscall/copy.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/syscall/copy.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
  */
 
+#include <assert.h>
 #include <syscall/copy.h>
 #include <proc/thread.h>
@@ -63,6 +64,6 @@
 	int rc;
 	
-	ASSERT(THREAD);
-	ASSERT(!THREAD->in_copy_from_uspace);
+	assert(THREAD);
+	assert(!THREAD->in_copy_from_uspace);
 	
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
@@ -114,6 +115,6 @@
 	int rc;
 	
-	ASSERT(THREAD);
-	ASSERT(!THREAD->in_copy_to_uspace);
+	assert(THREAD);
+	assert(!THREAD->in_copy_to_uspace);
 	
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
Index: kernel/generic/src/syscall/syscall.c
===================================================================
--- kernel/generic/src/syscall/syscall.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/syscall/syscall.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -45,5 +45,4 @@
 #include <arch.h>
 #include <debug.h>
-#include <ddi/device.h>
 #include <interrupt.h>
 #include <ipc/sysipc.h>
@@ -53,5 +52,5 @@
 #include <ddi/ddi.h>
 #include <ipc/event.h>
-#include <security/cap.h>
+#include <security/perm.h>
 #include <sysinfo/sysinfo.h>
 #include <console/console.h>
@@ -123,80 +122,78 @@
 syshandler_t syscall_table[SYSCALL_END] = {
 	/* System management syscalls. */
-	(syshandler_t) sys_kio,
+	[SYS_KIO] = (syshandler_t) sys_kio,
 	
 	/* Thread and task related syscalls. */
-	(syshandler_t) sys_thread_create,
-	(syshandler_t) sys_thread_exit,
-	(syshandler_t) sys_thread_get_id,
-	(syshandler_t) sys_thread_usleep,
-	(syshandler_t) sys_thread_udelay,
-	
-	(syshandler_t) sys_task_get_id,
-	(syshandler_t) sys_task_set_name,
-	(syshandler_t) sys_task_kill,
-	(syshandler_t) sys_task_exit,
-	(syshandler_t) sys_program_spawn_loader,
+	[SYS_THREAD_CREATE] = (syshandler_t) sys_thread_create,
+	[SYS_THREAD_EXIT] = (syshandler_t) sys_thread_exit,
+	[SYS_THREAD_GET_ID] = (syshandler_t) sys_thread_get_id,
+	[SYS_THREAD_USLEEP] = (syshandler_t) sys_thread_usleep,
+	[SYS_THREAD_UDELAY] = (syshandler_t) sys_thread_udelay,
+	
+	[SYS_TASK_GET_ID] = (syshandler_t) sys_task_get_id,
+	[SYS_TASK_SET_NAME] = (syshandler_t) sys_task_set_name,
+	[SYS_TASK_KILL] = (syshandler_t) sys_task_kill,
+	[SYS_TASK_EXIT] = (syshandler_t) sys_task_exit,
+	[SYS_PROGRAM_SPAWN_LOADER] = (syshandler_t) sys_program_spawn_loader,
 	
 	/* Synchronization related syscalls. */
-	(syshandler_t) sys_futex_sleep,
-	(syshandler_t) sys_futex_wakeup,
-	(syshandler_t) sys_smc_coherence,
-	(syshandler_t) sys_smp_memory_barrier,
-	
+	[SYS_FUTEX_SLEEP] = (syshandler_t) sys_futex_sleep,
+	[SYS_FUTEX_WAKEUP] = (syshandler_t) sys_futex_wakeup,
+	[SYS_SMC_COHERENCE] = (syshandler_t) sys_smc_coherence,
+	[SYS_SMP_MEMORY_BARRIER] = (syshandler_t) sys_smp_memory_barrier,
 	
 	/* Address space related syscalls. */
-	(syshandler_t) sys_as_area_create,
-	(syshandler_t) sys_as_area_resize,
-	(syshandler_t) sys_as_area_change_flags,
-	(syshandler_t) sys_as_area_destroy,
+	[SYS_AS_AREA_CREATE] = (syshandler_t) sys_as_area_create,
+	[SYS_AS_AREA_RESIZE] = (syshandler_t) sys_as_area_resize,
+	[SYS_AS_AREA_CHANGE_FLAGS] = (syshandler_t) sys_as_area_change_flags,
+	[SYS_AS_AREA_DESTROY] = (syshandler_t) sys_as_area_destroy,
 	
 	/* Page mapping related syscalls. */
-	(syshandler_t) sys_page_find_mapping,
+	[SYS_PAGE_FIND_MAPPING] = (syshandler_t) sys_page_find_mapping,
 	
 	/* IPC related syscalls. */
-	(syshandler_t) sys_ipc_call_async_fast,
-	(syshandler_t) sys_ipc_call_async_slow,
-	(syshandler_t) sys_ipc_answer_fast,
-	(syshandler_t) sys_ipc_answer_slow,
-	(syshandler_t) sys_ipc_forward_fast,
-	(syshandler_t) sys_ipc_forward_slow,
-	(syshandler_t) sys_ipc_wait_for_call,
-	(syshandler_t) sys_ipc_poke,
-	(syshandler_t) sys_ipc_hangup,
-	(syshandler_t) sys_ipc_connect_kbox,
+	[SYS_IPC_CALL_ASYNC_FAST] = (syshandler_t) sys_ipc_call_async_fast,
+	[SYS_IPC_CALL_ASYNC_SLOW] = (syshandler_t) sys_ipc_call_async_slow,
+	[SYS_IPC_ANSWER_FAST] = (syshandler_t) sys_ipc_answer_fast,
+	[SYS_IPC_ANSWER_SLOW] = (syshandler_t) sys_ipc_answer_slow,
+	[SYS_IPC_FORWARD_FAST] = (syshandler_t) sys_ipc_forward_fast,
+	[SYS_IPC_FORWARD_SLOW] = (syshandler_t) sys_ipc_forward_slow,
+	[SYS_IPC_WAIT] = (syshandler_t) sys_ipc_wait_for_call,
+	[SYS_IPC_POKE] = (syshandler_t) sys_ipc_poke,
+	[SYS_IPC_HANGUP] = (syshandler_t) sys_ipc_hangup,
+	[SYS_IPC_CONNECT_KBOX] = (syshandler_t) sys_ipc_connect_kbox,
 	
 	/* Event notification syscalls. */
-	(syshandler_t) sys_ipc_event_subscribe,
-	(syshandler_t) sys_ipc_event_unsubscribe,
-	(syshandler_t) sys_ipc_event_unmask,
-	
-	/* Capabilities related syscalls. */
-	(syshandler_t) sys_cap_grant,
-	(syshandler_t) sys_cap_revoke,
+	[SYS_IPC_EVENT_SUBSCRIBE] = (syshandler_t) sys_ipc_event_subscribe,
+	[SYS_IPC_EVENT_UNSUBSCRIBE] = (syshandler_t) sys_ipc_event_unsubscribe,
+	[SYS_IPC_EVENT_UNMASK] = (syshandler_t) sys_ipc_event_unmask,
+	
+	/* Permission related syscalls. */
+	[SYS_PERM_GRANT] = (syshandler_t) sys_perm_grant,
+	[SYS_PERM_REVOKE] = (syshandler_t) sys_perm_revoke,
 	
 	/* DDI related syscalls. */
-	(syshandler_t) sys_device_assign_devno,
-	(syshandler_t) sys_physmem_map,
-	(syshandler_t) sys_physmem_unmap,
-	(syshandler_t) sys_dmamem_map,
-	(syshandler_t) sys_dmamem_unmap,
-	(syshandler_t) sys_iospace_enable,
-	(syshandler_t) sys_iospace_disable,
-	
-	(syshandler_t) sys_ipc_irq_subscribe,
-	(syshandler_t) sys_ipc_irq_unsubscribe,
+	[SYS_PHYSMEM_MAP] = (syshandler_t) sys_physmem_map,
+	[SYS_PHYSMEM_UNMAP] = (syshandler_t) sys_physmem_unmap,
+	[SYS_DMAMEM_MAP] = (syshandler_t) sys_dmamem_map,
+	[SYS_DMAMEM_UNMAP] = (syshandler_t) sys_dmamem_unmap,
+	[SYS_IOSPACE_ENABLE] = (syshandler_t) sys_iospace_enable,
+	[SYS_IOSPACE_DISABLE] = (syshandler_t) sys_iospace_disable,
+	
+	[SYS_IPC_IRQ_SUBSCRIBE] = (syshandler_t) sys_ipc_irq_subscribe,
+	[SYS_IPC_IRQ_UNSUBSCRIBE] = (syshandler_t) sys_ipc_irq_unsubscribe,
 	
 	/* Sysinfo syscalls. */
-	(syshandler_t) sys_sysinfo_get_keys_size,
-	(syshandler_t) sys_sysinfo_get_keys,
-	(syshandler_t) sys_sysinfo_get_val_type,
-	(syshandler_t) sys_sysinfo_get_value,
-	(syshandler_t) sys_sysinfo_get_data_size,
-	(syshandler_t) sys_sysinfo_get_data,
+	[SYS_SYSINFO_GET_KEYS_SIZE] = (syshandler_t) sys_sysinfo_get_keys_size,
+	[SYS_SYSINFO_GET_KEYS] = (syshandler_t) sys_sysinfo_get_keys,
+	[SYS_SYSINFO_GET_VAL_TYPE] = (syshandler_t) sys_sysinfo_get_val_type,
+	[SYS_SYSINFO_GET_VALUE] = (syshandler_t) sys_sysinfo_get_value,
+	[SYS_SYSINFO_GET_DATA_SIZE] = (syshandler_t) sys_sysinfo_get_data_size,
+	[SYS_SYSINFO_GET_DATA] = (syshandler_t) sys_sysinfo_get_data,
 	
 	/* Kernel console syscalls. */
-	(syshandler_t) sys_debug_console,
-	
-	(syshandler_t) sys_klog,
+	[SYS_DEBUG_CONSOLE] = (syshandler_t) sys_debug_console,
+	
+	[SYS_KLOG] = (syshandler_t) sys_klog,
 };
 
Index: kernel/generic/src/sysinfo/stats.c
===================================================================
--- kernel/generic/src/sysinfo/stats.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/sysinfo/stats.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
  */
 
+#include <assert.h>
 #include <typedefs.h>
 #include <abi/sysinfo.h>
@@ -45,4 +46,5 @@
 #include <proc/thread.h>
 #include <interrupt.h>
+#include <stdbool.h>
 #include <str.h>
 #include <errno.h>
@@ -230,6 +232,6 @@
 static void produce_stats_task(task_t *task, stats_task_t *stats_task)
 {
-	ASSERT(interrupts_disabled());
-	ASSERT(irq_spinlock_locked(&task->lock));
+	assert(interrupts_disabled());
+	assert(irq_spinlock_locked(&task->lock));
 	
 	stats_task->task_id = task->taskid;
@@ -332,6 +334,6 @@
 static void produce_stats_thread(thread_t *thread, stats_thread_t *stats_thread)
 {
-	ASSERT(interrupts_disabled());
-	ASSERT(irq_spinlock_locked(&thread->lock));
+	assert(interrupts_disabled());
+	assert(irq_spinlock_locked(&thread->lock));
 	
 	stats_thread->thread_id = thread->tid;
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
  */
 
+#include <assert.h>
 #include <sysinfo/sysinfo.h>
 #include <mm/slab.h>
@@ -125,5 +126,5 @@
     sysinfo_item_t *subtree, sysinfo_return_t **ret, bool dry_run)
 {
-	ASSERT(subtree != NULL);
+	assert(subtree != NULL);
 	
 	sysinfo_item_t *cur = subtree;
@@ -191,5 +192,5 @@
     sysinfo_item_t **psubtree)
 {
-	ASSERT(psubtree != NULL);
+	assert(psubtree != NULL);
 	
 	if (*psubtree == NULL) {
@@ -204,9 +205,9 @@
 		*psubtree =
 		    (sysinfo_item_t *) slab_alloc(sysinfo_item_slab, 0);
-		ASSERT(*psubtree);
+		assert(*psubtree);
 		
 		/* Fill in item name up to the delimiter */
 		(*psubtree)->name = str_ndup(name, i);
-		ASSERT((*psubtree)->name);
+		assert((*psubtree)->name);
 		
 		/* Create subtree items */
@@ -268,5 +269,5 @@
 			sysinfo_item_t *item =
 			    (sysinfo_item_t *) slab_alloc(sysinfo_item_slab, 0);
-			ASSERT(item);
+			assert(item);
 			
 			cur->next = item;
@@ -274,5 +275,5 @@
 			/* Fill in item name up to the delimiter */
 			item->name = str_ndup(name, i);
-			ASSERT(item->name);
+			assert(item->name);
 			
 			/* Create subtree items */
@@ -291,5 +292,5 @@
 	
 	/* Unreachable */
-	ASSERT(false);
+	assert(false);
 	return NULL;
 }
@@ -649,5 +650,5 @@
 	
 	char *path = (char *) malloc(size + 1, 0);
-	ASSERT(path);
+	assert(path);
 	
 	if ((copy_from_uspace(path, ptr, size + 1) == 0) &&
@@ -699,4 +700,5 @@
 	
 	sysinfo_return_t ret;
+	ret.tag = SYSINFO_VAL_UNDEFINED;
 	
 	if (subtree != NULL) {
@@ -729,7 +731,4 @@
 			ret.data.size = size;
 		}
-	} else {
-		/* No item in the fixed sysinfo tree */
-		ret.tag = SYSINFO_VAL_UNDEFINED;
 	}
 	
@@ -760,5 +759,5 @@
 	
 	char *path = (char *) malloc(size + 1, 0);
-	ASSERT(path);
+	assert(path);
 	
 	if ((copy_from_uspace(path, ptr, size + 1) == 0) &&
Index: kernel/generic/src/udebug/udebug.c
===================================================================
--- kernel/generic/src/udebug/udebug.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/udebug/udebug.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,6 +38,7 @@
  */
 
+#include <assert.h>
+#include <debug.h>
 #include <synch/waitq.h>
-#include <debug.h>
 #include <udebug/udebug.h>
 #include <errno.h>
@@ -116,6 +117,6 @@
 void udebug_stoppable_begin(void)
 {
-	ASSERT(THREAD);
-	ASSERT(TASK);
+	assert(THREAD);
+	assert(TASK);
 	
 	mutex_lock(&TASK->udebug.lock);
@@ -125,5 +126,5 @@
 	/* Lock order OK, THREAD->udebug.lock is after TASK->udebug.lock */
 	mutex_lock(&THREAD->udebug.lock);
-	ASSERT(THREAD->udebug.stoppable == false);
+	assert(THREAD->udebug.stoppable == false);
 	THREAD->udebug.stoppable = true;
 	
@@ -136,5 +137,5 @@
 		
 		call_t *db_call = TASK->udebug.begin_call;
-		ASSERT(db_call);
+		assert(db_call);
 		
 		TASK->udebug.dt_state = UDEBUG_TS_ACTIVE;
@@ -158,5 +159,5 @@
 			call_t *go_call = THREAD->udebug.go_call;
 			THREAD->udebug.go_call = NULL;
-			ASSERT(go_call);
+			assert(go_call);
 			
 			IPC_SET_RETVAL(go_call->data, 0);
@@ -195,5 +196,5 @@
 	} else {
 		++TASK->udebug.not_stoppable_count;
-		ASSERT(THREAD->udebug.stoppable == true);
+		assert(THREAD->udebug.stoppable == true);
 		THREAD->udebug.stoppable = false;
 		
@@ -398,5 +399,5 @@
 int udebug_task_cleanup(struct task *task)
 {
-	ASSERT(mutex_locked(&task->udebug.lock));
+	assert(mutex_locked(&task->udebug.lock));
 
 	if ((task->udebug.dt_state != UDEBUG_TS_BEGINNING) &&
Index: kernel/generic/src/udebug/udebug_ipc.c
===================================================================
--- kernel/generic/src/udebug/udebug_ipc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/udebug/udebug_ipc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,6 @@
  * functions from the udebug_ops module which implement them.
  */
- 
+
+#include <assert.h>
 #include <proc/task.h>
 #include <proc/thread.h>
@@ -355,5 +356,5 @@
 	}
 
-	ASSERT(buffer != NULL);
+	assert(buffer != NULL);
 
 	/*
@@ -401,5 +402,5 @@
 	}
 
-	ASSERT(buffer != NULL);
+	assert(buffer != NULL);
 
 	IPC_SET_RETVAL(call->data, 0);
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -51,5 +51,5 @@
 #include <udebug/udebug.h>
 #include <udebug/udebug_ops.h>
-#include <memstr.h>
+#include <mem.h>
 
 /** Prepare a thread for a debugging operation.
Index: kernel/test/cht/cht1.c
===================================================================
--- kernel/test/cht/cht1.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/cht/cht1.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,7 +27,7 @@
  */
 
+#include <assert.h>
 #include <test.h>
 #include <print.h>
-#include <debug.h>
 #include <adt/cht.h>
 #include <synch/rcu.h>
@@ -45,5 +45,5 @@
 {
 	val_t *v = member_to_inst(item, val_t, link);
-	ASSERT(v->hash == (v->unique_id % 10));
+	assert(v->hash == (v->unique_id % 10));
 	return v->hash;
 }
@@ -70,5 +70,5 @@
 {
 	val_t *v = member_to_inst(item, val_t, link);
-	ASSERT(!v->deleted);
+	assert(!v->deleted);
 	v->deleted = true;
 	free(v);
@@ -364,5 +364,5 @@
 {
 	stress_work_t *work = (stress_work_t *)arg;
-	ASSERT(0 == *work->stop);
+	assert(0 == *work->stop);
 	
 	size_t loops = 0;
@@ -528,5 +528,5 @@
 			thr[i] = thread_create(resize_stresser, &pwork[i], TASK, 0, "cht-resize");
 		
-		ASSERT(thr[i]);
+		assert(thr[i]);
 		thread_wire(thr[i], &cpus[i % config.cpu_active]);
 		thread_ready(thr[i]);
Index: kernel/test/debug/mips1_skip.c
===================================================================
--- kernel/test/debug/mips1_skip.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/debug/mips1_skip.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,4 +28,5 @@
 
 #include <test.h>
+#include <stddef.h>
 
 const char *test_mips1(void)
Index: kernel/test/mm/falloc2.c
===================================================================
--- kernel/test/mm/falloc2.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/mm/falloc2.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 #include <debug.h>
 #include <proc/thread.h>
-#include <memstr.h>
+#include <mem.h>
 #include <arch.h>
 
Index: kernel/test/mm/purge1_skip.c
===================================================================
--- kernel/test/mm/purge1_skip.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/mm/purge1_skip.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,4 +27,5 @@
  */
 
+#include <stddef.h>
 #include <test.h>
 
Index: kernel/test/mm/slab1.c
===================================================================
--- kernel/test/mm/slab1.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/mm/slab1.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -32,5 +32,5 @@
 #include <proc/thread.h>
 #include <arch.h>
-#include <memstr.h>
+#include <mem.h>
 
 #define VAL_COUNT  1024
Index: kernel/test/mm/slab2.c
===================================================================
--- kernel/test/mm/slab2.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/mm/slab2.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,5 @@
 #include <arch.h>
 #include <mm/frame.h>
-#include <memstr.h>
+#include <mem.h>
 #include <synch/condvar.h>
 #include <synch/mutex.h>
Index: kernel/test/print/print1.c
===================================================================
--- kernel/test/print/print1.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/print/print1.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,4 +28,5 @@
 
 #include <print.h>
+#include <stddef.h>
 #include <test.h>
 
Index: kernel/test/print/print2.c
===================================================================
--- kernel/test/print/print2.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/print/print2.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,4 +28,5 @@
 
 #include <print.h>
+#include <stddef.h>
 #include <test.h>
 
@@ -61,5 +62,5 @@
 	TPRINTF("Real output:     [%td] [%tu] [%tx] [%ti] [%to]\n\n", d, neg_d, neg_d, d, neg_d);
 	
-	sysarg_t nat = UINTN_C(0x12345678);
+	sysarg_t nat = 0x12345678;
 	
 	TPRINTF("Testing printf(\"%%#" PRIx64 " %%#" PRIx32 " %%#" PRIx16 " %%#" PRIx8 " %%#" PRIxn " %%#" PRIx64 " %%s\", (uint64_t) UINT64_C(0x1234567887654321), (uint32_t) UINT32_C(0x12345678), (uint16_t) UINT16_C(0x1234), (uint8_t) UINT8_C(0x12), nat, (uint64_t) UINT64_C(0x1234567887654321), \"Lovely string\"):\n");
Index: kernel/test/print/print3.c
===================================================================
--- kernel/test/print/print3.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/print/print3.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,6 +27,7 @@
  */
 
+#include <macros.h>
 #include <print.h>
-#include <macros.h>
+#include <stddef.h>
 #include <test.h>
 
Index: kernel/test/print/print4.c
===================================================================
--- kernel/test/print/print4.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/print/print4.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,4 +28,5 @@
 
 #include <print.h>
+#include <stddef.h>
 #include <test.h>
 
Index: kernel/test/print/print5.c
===================================================================
--- kernel/test/print/print5.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/print/print5.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,4 +40,5 @@
 
 #include <print.h>
+#include <stddef.h>
 #include <test.h>
 
Index: kernel/test/smpcall/smpcall1.c
===================================================================
--- kernel/test/smpcall/smpcall1.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/smpcall/smpcall1.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,4 +30,5 @@
 #include <debug.h>
 
+#include <assert.h>
 #include <test.h>
 #include <smp/smp_call.h>
@@ -50,5 +51,5 @@
 static void inc(void *p)
 {
-	ASSERT(interrupts_disabled());
+	assert(interrupts_disabled());
 
 	size_t *pcall_cnt = (size_t*)p;
Index: kernel/test/synch/rcu1.c
===================================================================
--- kernel/test/synch/rcu1.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/synch/rcu1.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,4 +27,5 @@
  */
 
+#include <assert.h>
 #include <test.h>
 #include <arch.h>
@@ -81,5 +82,5 @@
 static void run_thread(size_t k, void (*func)(void*), void *arg)
 {
-	ASSERT(thread[k] == NULL);
+	assert(thread[k] == NULL);
 	
 	thread[k] = thread_create(func, arg, TASK, THREAD_FLAG_NONE, 
@@ -130,5 +131,5 @@
 static void run_one(void (*func)(void*), void *arg)
 {
-	ASSERT(one_idx < MAX_THREADS);
+	assert(one_idx < MAX_THREADS);
 	run_thread(one_idx, func, arg);
 	++one_idx;
@@ -138,5 +139,5 @@
 static void join_one(void)
 {
-	ASSERT(0 < one_idx && one_idx <= MAX_THREADS);
+	assert(0 < one_idx && one_idx <= MAX_THREADS);
 
 	--one_idx;
@@ -168,5 +169,5 @@
 static void get_seq(size_t from, size_t to, size_t steps, size_t *seq)
 {
-	ASSERT(0 < steps && from <= to && 0 < to);
+	assert(0 < steps && from <= to && 0 < to);
 	size_t inc = (to - from) / (steps - 1);
 	
@@ -304,5 +305,5 @@
 static void one_cb_done(rcu_item_t *item)
 {
-	ASSERT( ((item_w_cookie_t *)item)->cookie == magic_cookie);
+	assert( ((item_w_cookie_t *)item)->cookie == magic_cookie);
 	one_cb_is_done = 1;
 	TPRINTF("Callback()\n");
@@ -388,4 +389,9 @@
 static void seq_func(void *arg)
 {
+	/*
+	 * Temporarily workaround GCC 7.1.0 internal
+	 * compiler error when compiling for riscv64.
+	 */
+#ifndef KARCH_riscv64
 	seq_work_t *work = (seq_work_t*)arg;
 	
@@ -434,5 +440,8 @@
 		}
 		
-	} 
+	}
+#else
+	(void) seq_cb;
+#endif
 }
 
@@ -560,5 +569,5 @@
 {
 	preempt_t *p = (preempt_t*)arg;
-	ASSERT(!p->e.exited);
+	assert(!p->e.exited);
 
 	TPRINTF("reader_prev{ ");
@@ -580,5 +589,5 @@
 {
 	preempt_t *p = (preempt_t*)arg;
-	ASSERT(!p->e.exited);
+	assert(!p->e.exited);
 	
 	TPRINTF("reader_inside_cur{ ");
@@ -605,5 +614,5 @@
 {
 	preempt_t *p = (preempt_t*)arg;
-	ASSERT(!p->e.exited);
+	assert(!p->e.exited);
 	
 	TPRINTF("reader_cur{ ");
@@ -627,5 +636,5 @@
 {
 	preempt_t *p = (preempt_t*)arg;
-	ASSERT(!p->e.exited);
+	assert(!p->e.exited);
 	
 	TPRINTF("reader_next1{ ");
@@ -649,5 +658,5 @@
 {
 	preempt_t *p = (preempt_t*)arg;
-	ASSERT(!p->e.exited);
+	assert(!p->e.exited);
 	
 	TPRINTF("reader_next2{ ");
Index: kernel/test/synch/workq-test-core.h
===================================================================
--- kernel/test/synch/workq-test-core.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/synch/workq-test-core.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,4 +27,5 @@
  */
 
+#include <assert.h>
 #include <test.h>
 #include <arch.h>
@@ -32,5 +33,5 @@
 #include <print.h>
 #include <proc/thread.h>
-#include <memstr.h>
+#include <mem.h>
 #include <synch/workqueue.h>
 
@@ -72,5 +73,5 @@
 {
 	test_work_t *child = malloc(sizeof(test_work_t), 0);
-	ASSERT(child);
+	assert(child);
 	if (child) {
 		child->master = false;
Index: kernel/test/synch/workqueue2.c
===================================================================
--- kernel/test/synch/workqueue2.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/synch/workqueue2.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,4 @@
 #include <arch.h>
 #include <print.h>
-#include <memstr.h>
 #include <synch/workqueue.h>
 
Index: kernel/test/synch/workqueue3.c
===================================================================
--- kernel/test/synch/workqueue3.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/synch/workqueue3.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,4 @@
 #include <arch.h>
 #include <print.h>
-#include <memstr.h>
 #include <synch/workqueue.h>
 
Index: kernel/test/test.c
===================================================================
--- kernel/test/test.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/test.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
 
 #include <test.h>
+#include <stddef.h>
 #include <str.h>
 
Index: kernel/test/test.h
===================================================================
--- kernel/test/test.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/test/test.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_TEST_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
 
 extern bool test_quiet;
